module Parsing.Syntax where


{--------------------------------------------------------------------
--	Internal representation of a syntax definition
--------------------------------------------------------------------}

data SyntaxGrammar = SyntaxGrammar {
	startSyntaxes :: [String],
	skipped :: [String],
	delimiters :: [String],
	rules :: [(String, ParseRule)],
	bodies :: [(String, [String])]
	}


data ParseRule
	= Syntax SyntaxRule
	| Token TokenType String


data TokenType = Bounded | Greedy

data SyntaxRule
	= Either     [SyntaxRule]
	| Sequence   [SyntaxRule]

	| Maybe       SyntaxRule
	| ZeroOrMore  SyntaxRule
	| OneOrMore   SyntaxRule

	| Rule         String
	| DirectToken  String

